// Copyright 2008 Brian Caine

// This file is part of Potpourri.

// Potpourri is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Potpourri is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTIBILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Potpourri. If not, see <http://www.gnu.org/licenses/>.


// NOTES:
// An autogenerated xml parser.

// Hooray! Shit!

#ifndef __PARSEACTOR_H
#define __PARSEACTOR_H

#include <string>
#include <libxml++/libxml++.h>

namespace XMLParser
{  
  namespace parseactor
    {
      struct pos
        {
          std::string m_pair;
        };

      struct param
        {
          std::string name;
          std::string type;
          std::string value;
        };

      struct graphics
        {
          std::string m_source;
          pos m_pos;
          float m_angle;
          std::vector<param> m_params;
        };

      struct body
        {
          float m_mass;
          float m_inertia;
          float m_rotational_inertia;
          bool generate_rotational_inertia;
          bool m_fixed;
        };

      struct data
        {
          std::vector<std::string> m_pair;
        };

      struct offset
        {
          std::string m_pair;
        };

      struct poly
        {
          data m_data;
          offset m_offset;
          float m_elasticity;
          float m_friction;
        };

      struct circle
        {
          offset m_offset;
          float m_radius;
          float m_elasticity;
          float m_friction;
        };

      struct line
        {
          std::string m_a;
          std::string m_b;
          float m_radius;
          float m_elasticity;
          float m_friction;
        };

      struct physics
        {
          body m_body;
          std::vector<poly> m_poly;
          std::vector<circle> m_circle;
          std::vector<line> m_line;
        };

      struct reaction
        {
          std::string m_event;
          std::string m_script;
        };

      struct actor
        {
          std::string m_name;
          std::vector<graphics> m_graphics;
          physics m_physics;
          std::vector<reaction> m_reaction;
        };

      actor parseactorFromBuffer(std::string);

      param parseparam(xmlpp::Node*);
      float parseelasticity(xmlpp::Node*);
      float parsefriction(xmlpp::Node*);
      actor parseactor(xmlpp::Node*);
      std::string parseevent(xmlpp::Node*);
      std::string parsescript(xmlpp::Node*);
      reaction parsereaction(xmlpp::Node*);
      std::string parsepair(xmlpp::Node*);
      std::string parsepair(xmlpp::Node*);
      float parseradius(xmlpp::Node*);
      std::string parsepair(xmlpp::Node*);
      offset parseoffset(xmlpp::Node*);
      offset parseoffset(xmlpp::Node*);
      std::string parsepair(xmlpp::Node*);
      offset parseoffset(xmlpp::Node*);
      data parsedata(xmlpp::Node*);
      data parsedata(xmlpp::Node*);
      offset parseoffset(xmlpp::Node*);
      poly parsepoly(xmlpp::Node*);
      float parsemass(xmlpp::Node*);
      float parseinertia(xmlpp::Node*);
      bool parsefixed(xmlpp::Node*);
      body parsebody(xmlpp::Node*);
      body parsebody(xmlpp::Node*);
      poly parsepoly(xmlpp::Node*);
      circle parsecircle(xmlpp::Node*);
      line parseline(xmlpp::Node*);
      physics parsephysics(xmlpp::Node*);
      std::string parsepair(xmlpp::Node*);
      pos parsepos(xmlpp::Node*);
      std::string parsesource(xmlpp::Node*);
      pos parsepos(xmlpp::Node*);
      float parseangle(xmlpp::Node*);
      graphics parsegraphics(xmlpp::Node*);
    }
}

#endif
